const setHeaders = new Headers()
setHeaders.append('Content-Type', 'application/json')
setHeaders.append('Origin', 'http://codenames.zsqlm.cn')
const originOptions = {
  headers: setHeaders,
  // 为了让浏览器发送包含凭据的请求（即使是跨域源）
  credentials: 'include',
  cache: 'no-cache',
  referrer: 'client'
}
const http = (url = '', params = {}, options = {}) => {
  const sendOptions = Object.assign({}, originOptions, options)
  if (!sendOptions.method || sendOptions.method === 'GET') {
    Object.entries(params).forEach(([key, value], i) => {
      if (i === 0) {
        url += `?${key}=${value}`
      } else {
        url += `&${key}=${value}`
      }
    })
  } else {
    sendOptions.body = JSON.stringify(params)
  }
  return window.fetch(url, sendOptions)
}
const get = (url, params, options) => http(url, params, options).then(res => res.json())
const post = (url, params, options) => {
  const getOptions = Object.assign({}, options, { method: 'POST' })
  return http(url, params, getOptions).then(res => res.json())
}
const put = (url, params, options) => {
  const getOptions = Object.assign({}, options, { method: 'PUT' })
  return http(url, params, getOptions).then(res => res.json())
}
const del = (url, params, options) => {
  const getOptions = Object.assign({}, options, { method: 'DELETE' })
  return http(url, params, getOptions).then(res => res.json())
}
export default {
  get,
  post,
  put,
  del
}
